const id2str = require(`./id2str`);

function aggregateData(req, res, next) {
    const newResult = []
    const aggregateFields = ['gender']
    let id;
    const fields = req.query.dims.split(',');
    let currentAggregateField;
    let currentNonAggregateField;
    fields.forEach(field => {if (aggregateFields.includes(field)) currentAggregateField = field; else currentNonAggregateField = field});
    if (currentAggregateField) {
        console.log(currentAggregateField);
        req.result.forEach((r) => {
            id = 1;
            for (const property in r) {
                if (property.includes("total_")) {
                    const data = {
                        total: r[property],
                        year: r.year,
                        [`${currentAggregateField}_id`]: id,
                        [`${currentAggregateField}_name`]: id2str[currentAggregateField](id)
                    }
    
                    if (currentNonAggregateField) {
                        data[`${currentNonAggregateField}_id`] = r[`${currentNonAggregateField}_id`];
                        console.log(currentNonAggregateField)
                        data[`${currentNonAggregateField}_name`] = id2str[`${currentNonAggregateField}_id`](id);
                    }
    
                    newResult.push(data)
                    ++id;
                }
            }
        })
        req.result = newResult;
    }
    console.log(req.result);
    next();
}

module.exports = aggregateData;